/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.diacalc.mobile.components;

/**
 *
 * @author Константин
 */
import com.sun.lwuit.*;
import com.sun.lwuit.animations.CommonTransitions;
import com.sun.lwuit.animations.Transition;
import com.sun.lwuit.events.ActionEvent;
import com.sun.lwuit.events.ActionListener;
import com.sun.lwuit.layouts.BorderLayout;
import com.sun.lwuit.layouts.GridLayout;
import com.sun.lwuit.layouts.Layout;
import java.util.Vector;

public class BackForm extends Form{
       private Container contentPane = new Container();
       //private Container title = new Container(new BoxLayout(BoxLayout.X_AXIS));
       private Container title = new Container(new BorderLayout());
       private Label titleLabel;
       private Button menuButton;
       private Dialog dl = null;
       private static Transition out = CommonTransitions.createSlide(CommonTransitions.SLIDE_VERTICAL, true, 200);
       private static Transition in = CommonTransitions.createSlide(CommonTransitions.SLIDE_VERTICAL, false, 200);

       public BackForm(String formName,Command backCommand) {
           super.getContentPane().setLayout(new BorderLayout());
           super.getContentPane().addComponent(BorderLayout.CENTER, contentPane);
           super.getContentPane().addComponent(BorderLayout.NORTH, title);
           super.setScrollable(false);
           
           titleLabel = new Label(formName);
           title.getStyle().setPadding(0, 0, 0, 0);
           title.getStyle().setMargin(0, 0, 0, 0);
           titleLabel.getStyle().setPadding(0, 0, 0, 0);
           titleLabel.getStyle().setMargin(0, 0, 40, 0);
           titleLabel.getStyle().setBgTransparency(0);
           title.setUIID("Title");
           Button backButton = new Button(backCommand);
           backButton.setUIID("ButtonBack");
           backButton.setPreferredH(29);//42
           
           title.addComponent(BorderLayout.WEST,backButton);
           
           title.addComponent(BorderLayout.CENTER,titleLabel);
           
           
           menuButton = new Button();
           menuButton.setText("");
           menuButton.setPreferredH(29);
           menuButton.setPreferredW(29);
           menuButton.setUIID("ButtonMenu");
           menuButton.addActionListener(menuListener);
           menuButton.setFocusable(false);
           
           title.addComponent(BorderLayout.EAST, menuButton);
           
           //setTransitionOutAnimator(CommonTransitions.createFade(200));
           //setTransitionInAnimator(CommonTransitions.createFade(200));
       }
       
               
       public void setTitle(String st){
           titleLabel.setText(st);
       }
       public String getTitle(){
           return titleLabel.getText();
       }
       public Container getContentPane() {
           return contentPane;
       }
       
       /*Делаем своё меню, которое будет совсем не меню*/
       private Vector _menuCommands = new Vector();
       
       
       public void addMenuCommand(Command c, ActionListener l){
           _menuCommands.addElement(new MenuCommand(c,l));
       }
       public int getMenuCommandsSize(){
           return _menuCommands.size();
       }
       public void removeMenuCommand(int i){
           _menuCommands.removeElementAt(i);
       }
       public void removeMenuCommand(Command c){
           removeMenuCommand(getMenuCommandIndx(c));
       }
       public int getMenuCommandIndx(Command c){
           for(int i=0;i<_menuCommands.size();i++){
               if ( ((MenuCommand)(_menuCommands.elementAt(i))).getCommand().equals(c) ){
                   return i;
               }
           }
           return -1;
       }
       public ActionListener getMenuCommandListener(Command c){
           for(int i=0;i<_menuCommands.size();i++){
               if ( ((MenuCommand)(_menuCommands.elementAt(i))).getCommand().equals(c) ){
                   return ((MenuCommand)(_menuCommands.elementAt(i))).getListener();
               }
           }
           return null;
       }
       
       public Command getMenuCommand(int i){
           return ((MenuCommand)_menuCommands.elementAt(i)).getCommand();
       }
       
       private ActionListener menuListener = new ActionListener(){
            public void actionPerformed(ActionEvent ae) {
                if (getMenuCommandsSize()==0) return;
                if (getMenuCommandsSize()==1){
                    //Выполняем сразу команду без показа меню
                    ((MenuCommand)_menuCommands.firstElement()).getListener()
                            .actionPerformed(
                            new ActionEvent(((MenuCommand)_menuCommands.firstElement()).getCommand(),
                            menuButton,ae.getX(),ae.getY()));
                    
                    //..actionCommand( ((Command)_menuCommands.elementAt(0)) );
                    //((Command)_menuCommands.elementAt(0)).get(null);
                }else{//А вот тут показываем меню
                    int x = 2;//В любом случае два столбца
                    int ost = _menuCommands.size() % 2;
                    int y = _menuCommands.size() /  2;
                    
                    Container c = new Container(new GridLayout(y,x));
                    for (int i=0;i<(_menuCommands.size()-ost);i++){
                        Button b = new Button(
                                ((MenuCommand)_menuCommands.elementAt(i)).getCommand()
                                            );
                        b.addActionListener(internalListener);
                        c.addComponent(b);
                    }
                    dl = new Dialog();
//                    dl.getContentPane().setUIID("MenuDialog");
                    dl.setTransitionInAnimator(in);
                    dl.setTransitionOutAnimator(out);
                    
                    if (ost>0){
                        Container c2 = new Container(new BorderLayout());
                        c2.addComponent(BorderLayout.CENTER, c);
                        Button b = new Button( ((MenuCommand)_menuCommands.lastElement()).getCommand() );
                        b.addActionListener(internalListener);
                
                        c2.addComponent(BorderLayout.SOUTH, b);
                        dl.addComponent(c2);
                    }
                    else{
                        dl.addComponent(c);
                    }
                        
                    dl.setDisposeWhenPointerOutOfBounds(true);
                
                    dl.showPacked(BorderLayout.NORTH, true);
                }
            }
       };
       
       private ActionListener internalListener = new ActionListener(){
        public void actionPerformed(ActionEvent ae) {//Сначала необходимо закрывать меню, 
            //иначе после его скрывания с экрана будет показана форма
            //которая была изначально под этим меню
            if (dl!=null) { dl.dispose(); dl = null; }
            getMenuCommandListener(ae.getCommand()).actionPerformed(
                            new ActionEvent(ae.getCommand(),
                            ae.getComponent(),ae.getX(),ae.getY()));
        }
           
       };
       /**
        * Removes all Components from the Content Pane
        */
       public void removeAll() {
           contentPane.removeAll();
       }


       /**
        * @inheritDoc
        */
       public void setLayout(Layout layout) {
           contentPane.setLayout(layout);
       }

       /**
        * Adds Component to the Form's Content Pane
        *
        * @param cmp the added param
        */
       public void addComponent(Component cmp) {
           contentPane.addComponent(cmp);
       }

       /**
        * @inheritDoc
        */
       public void addComponent(Object constraints, Component cmp) {
           contentPane.addComponent(constraints, cmp);
       }

       /**
        * @inheritDoc
        */
       public void addComponent(int index, Object constraints, Component cmp) {
           contentPane.addComponent(index, constraints, cmp);
       }

       /**
        * Adds Component to the Form's Content Pane
        *
        * @param cmp the added param
        */
       public void addComponent(int index, Component cmp) {
           contentPane.addComponent(index, cmp);
       }

       /**
        * @inheritDoc
        */
       public void replace(Component current, Component next, Transition t) {
           contentPane.replace(current, next, t);
       }

       /**
        * @inheritDoc
        */
       public void replaceAndWait(Component current, Component next, Transition t) {
           contentPane.replaceAndWait(current, next, t);
       }

       /**
        * Removes a component from the Form's Content Pane
        *
        * @param cmp the component to be removed
        */
       public void removeComponent(Component cmp) {
           contentPane.removeComponent(cmp);
       }
       
       private Vector rotationLsnrs = new Vector();
       public void addRotationListener(RotationListener l){
           rotationLsnrs.addElement(l);
       }
       public void removeRotationListener(RotationListener l){
           rotationLsnrs.removeElement(l);
       }
       protected void sizeChanged(int w, int h) {
        if(w == getHeight() && h == getWidth()){
            //rotated
            for(int i=0;i<rotationLsnrs.size();i++){
                ((RotationListener)rotationLsnrs.elementAt(i)).rotationHappend();
            }
        }
        super.sizeChanged(w,h);
       }
   }